require 'socket'

socket = Socket.new(:INET, :STREAM)
remote_addr = Socket.pack_sockaddr_in(80, 'google.com')

begin
  # Initiate a nonblocking connection to google.com on port 80.
  socket.connect_nonblock(remote_addr)
rescue Errno::EINPROGRESS
  # Operation is in progress.
rescue Errno::EALREADY
  # A previous nonblocking connect is already in progress.
rescue Errno::ECONNREFUSED
  # The remote host refused our connect.
end

