require 'socket'
require 'timeout'

module SelectBasedTimeout
  CHUNK_SIZE = 1024 * 16

  def read_data(timeout = 5)
    begin
      read_nonblock(CHUNK_SIZE)
    rescue Errno::EAGAIN
      if IO.select([self], nil, nil, timeout)
        retry
      else
        raise Timeout::Error
      end
    end
  end

  def write_data(data, timeout)
    written = 0

    loop do
      written = write_nonblock(data)
      break if written == data.size

      data = data[written..-1]
    end
  end
end

